/* DROP TABLES */
DROP TABLE OWNERSHIP IF EXISTS;
DROP TABLE BOOKS IF EXISTS;
DROP TABLE CATEGORIES IF EXISTS;
DROP TABLE USERS IF EXISTS;

/* USERS */
CREATE TABLE USERS (
	ID          VARCHAR(10)     PRIMARY KEY,
	PASSWORD    VARCHAR(10)     NOT NULL,
	UPDATE_DATE DATE         NOT NULL,
	CREATE_DATE DATE         NOT NULL
);

/* CATEGORIES */
CREATE TABLE CATEGORIES (
	ID          CHAR(2)      PRIMARY KEY,
	NAME        VARCHAR(256) NOT NULL,
	UPDATE_DATE DATE         NOT NULL,
	CREATE_DATE DATE         NOT NULL
);

/* BOOKS */
CREATE TABLE BOOKS (
	ISBN        CHAR(10)     PRIMARY KEY,
	TITLE       VARCHAR(256) NOT NULL,
	AUTHOR      VARCHAR(256) NOT NULL,
	CATEGORY    CHAR(2)      NOT NULL,
	UPDATE_DATE DATE         NOT NULL,
	CREATE_DATE DATE         NOT NULL,
	FOREIGN KEY (CATEGORY) REFERENCES CATEGORIES (ID)
);

/* OWNERSHIP */
CREATE TABLE OWNERSHIP (
	BOOK        CHAR(10)    NOT NULL,
	OWNER       VARCHAR(10) NOT NULL,
	UPDATE_DATE DATE        NOT NULL,
	CREATE_DATE DATE        NOT NULL,
	PRIMARY KEY (BOOK, OWNER),
	FOREIGN KEY (BOOK) REFERENCES BOOKS (ISBN),
	FOREIGN KEY (OWNER) REFERENCES USERS (ID)
);
