package hondana.businesslogic;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import hondana.util.database.QueryRunner;
import hondana.view.View;
import hondana.exception.SystemException;
import hondana.object.Request;
import hondana.object.Session;
import hondana.object.ViewStack;

/**
 * 抽象業務ロジック
 */
public abstract class AbstractBusinessLogic implements BusinessLogic {

    protected Log logger = LogFactory.getLog(this.getClass());

    /////////////////////////////////////////////////////////////////
    // request property

    protected Request request = null;

    public void setRequest(Request request) {
        this.request = request;
    }

    /////////////////////////////////////////////////////////////////
    // session property

    protected Session session = null;

    public void setSession(Session session) {
        this.session = session;
    }

    /////////////////////////////////////////////////////////////////
    // view stack property

    protected ViewStack stack = null;

    public void setViewStack(ViewStack stack) {
        this.stack = stack;
    }

    /////////////////////////////////////////////////////////////////
    // view property

    protected View view = null;

    public void setView(View view) {
        this.view = view;
    }

    /////////////////////////////////////////////////////////////////
    // query runner property

    protected boolean requiresQueryRunner = false;

    public boolean isNecessityQueryRunner() {
        return requiresQueryRunner;
    }

    protected QueryRunner qr = null;

    public void setQueryRunner(QueryRunner qr) {
        this.qr = qr;
    }

    /////////////////////////////////////////////////////////////////
    // business process

    public Object error(Exception ex) {
        throw new SystemException("error() is not implemented");
    }

    private boolean failed = false;

    public boolean isFailed() {
        return failed;
    }

    public void setFailed(boolean failed) {
        this.failed = failed;
    }

}