package hondana.businesslogic;

import hondana.util.database.QueryRunner;
import hondana.view.View;
import hondana.object.Request;
import hondana.object.Session;
import hondana.object.ViewStack;

/**
 * 業務ロジック
 */
public interface BusinessLogic {

    /////////////////////////////////////////////////////////////////
    // injection method

    public void setRequest(Request request);

    public void setSession(Session session);

    public void setViewStack(ViewStack stack);

    public void setView(View view);

    public boolean isNecessityQueryRunner();

    public void setQueryRunner(QueryRunner qr);

    /////////////////////////////////////////////////////////////////
    // business process

    public Object execute();

    public Object error(Exception ex);

    public boolean isFailed();

    public void setFailed(boolean failed);

}