package hondana.businesslogic;

import hondana.exception.BusinessException;
import hondana.view.IndexView;

/**
 * 持ち主削除
 */
public class DeleteOwner extends AbstractBusinessLogic {

    {
        // クエリーランナーを取得。
        requiresQueryRunner = true;
    }

    public Object execute() {
        IndexView in = (IndexView) view;

        // ISBN、ユーザIDを取得。
        String isbn = in.getIsbn();
        String userId = session.getUser().getUserId();

        Object[] params = { isbn, userId };

        // 持ち主登録されているかチェック。
        Integer oscount = (Integer) qr.getOne(
                "select count(*) from OWNERSHIP where BOOK = ? and OWNER = ?",
                params);

        if (oscount.intValue() < 1)
            throw BusinessException.DO001;

        // 持ち主情報を削除。
        qr.update("delete from OWNERSHIP where BOOK = ? and OWNER = ?", params);

        // 持ち主がいなくなった本は削除。
        Integer bkcount = (Integer) qr.getOne(
                "select count(*) from OWNERSHIP where BOOK = ?", isbn);

        if (bkcount.intValue() < 1)
            qr.update("delete from BOOKS where ISBN = ?", isbn);

        // インデックス表示処理を返す。
        return new Index();
    }

    public Object error(Exception ex) {
        // インデックス表示処理を返す。
        return new Index();
    }

}