package hondana.businesslogic;

import hondana.exception.BusinessException;
import hondana.object.User;
import hondana.view.DeleteUserConfirmView;
import hondana.view.DeleteUserInputView;

/**
 * 削除ユーザ入力
 */
public class DeleteUserConfirm extends AbstractBusinessLogic {

    {
        // クエリーランナーを取得。
        requiresQueryRunner = true;
    }

    public Object execute() {
        DeleteUserInputView in = (DeleteUserInputView) view;

        // ユーザIDとパスワードを取得。
        User user = session.getUser();
        String userId = user.getUserId();
        String password = in.getPassword();

        // パスワードが正しいかチェック。
        Object[] params = { userId, password };
        Integer count = (Integer) qr.getOne(
                "select count(ID) from USERS where ID = ? and PASSWORD = ?",
                params);

        if (count.intValue() < 1)
            throw BusinessException.DU001;

        // ビューを生成して、ユーザIDとパスワードをセット。
        DeleteUserConfirmView out = new DeleteUserConfirmView();
        out.setUserId(userId);
        out.setPassword(password);

        // ビューを返す。
        return out;
    }

    public Object error(Exception ex) {
        // ビューに「戻る」フラグをセット。
        view.setReturned(true);
        // ビューを返す。
        return view;
    }

}