package hondana.businesslogic;

import hondana.object.User;
import hondana.view.DeleteUserComplateView;
import hondana.view.DeleteUserConfirmView;

/**
 * ユーザ削除
 */
public class DeleteUserDelete extends AbstractBusinessLogic {

    {
        // クエリーランナーを取得。
        requiresQueryRunner = true;
    }

    public Object execute() {
        DeleteUserConfirmView in = (DeleteUserConfirmView) view;

        // セッションからユーザを取得。
        User user = session.getUser();

        // ユーザIDとパスワードを取得。
        String userId = user.getUserId();
        String password = in.getPassword();

        // 持ち主情報を削除。
        qr.update("delete from OWNERSHIP where OWNER = ?", userId);

        // ユーザ情報を削除
        Object[] params = { userId, password };
        qr.update("delete from USERS where ID = ? and PASSWORD = ?", params);

        // 持ち主がいなくなった本を削除。
        qr.update("delete from BOOKS BO where not exists "
                + "(select 'X' from OWNERSHIP OW where OW.BOOK = BO.ISBN)");

        // ユーザをセッションから削除。
        session.removeUser();

        // ビューを生成して、ユーザIDをセット。
        DeleteUserComplateView out = new DeleteUserComplateView();
        out.setUserId(userId);

        // ビューを返す。
        return out;
    }

}