package hondana.businesslogic;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import hondana.util.Utils;
import hondana.view.IndexView;

/**
 * インデックス表示
 */
public class Index extends AbstractBusinessLogic {

    {
        // クエリーランナーを取得。
        requiresQueryRunner = true;
    }

    public Object execute() {
        // 本の情報を取得。
        Map[] books = qr
                .query("select BO.ISBN, BO.TITLE, BO.AUTHOR, CA.NAME CATEGORY "
                        + "from BOOKS BO, CATEGORIES CA where BO.CATEGORY = CA.ID "
                        + "order by BO.ISBN");

        // 持ち主の情報を取得。
        Map[] books_owners = qr
                .query("select BOOK, OWNER from OWNERSHIP order by OWNER");
        Map ownership = new HashMap();

        for (int i = 0; i < books_owners.length; i++) {
            String book = (String) books_owners[i].get("book");
            String owner = (String) books_owners[i].get("owner");
            List owners = (List) ownership.get(book);

            if (owners == null) {
                owners = new ArrayList();
                ownership.put(book, owners);
            }

            owners.add(owner);
        }

        // 入力ビューを出力ビューをとする。
        IndexView out = (IndexView) view;

        // ビューに検索結果を格納。
        for (int i = 0; i < books.length; i++) {
            String isbn = (String) books[i].get("isbn");
            String title = (String) books[i].get("title");
            String author = (String) books[i].get("author");
            String category = (String) books[i].get("category");
            List ownerList = (List) ownership.get(isbn);
            String owners = Utils.join(ownerList, ", ");
            out.addBook(isbn, title, author, category, owners);
        }

        // ビューを返す。
        return out;
    }

}