package hondana.businesslogic;

import hondana.exception.BusinessException;
import hondana.object.User;
import hondana.view.LoginComplateView;
import hondana.view.LoginInputView;

/**
 * ログイン
 */
public class Login extends AbstractBusinessLogic {

    {
        // クエリーランナーを取得。
        requiresQueryRunner = true;
    }

    public Object execute() {
        LoginInputView in = (LoginInputView) view;

        // ユーザIDとパスワードを取得。
        String userId = in.getUserId();
        String password = in.getPassword();

        // ユーザを検索。
        Object[] params = { userId, password };
        Integer count = (Integer) qr.getOne(
                "select count(ID) from USERS where ID = ? and PASSWORD = ?",
                params);

        if (count.intValue() < 1)
            throw BusinessException.LO001;

        // ユーザをセッションにセット。
        User user = new User();
        user.setUserId(userId);
        session.setUser(user);

        // ビューを生成して、ユーザIDをセット。
        LoginComplateView out = new LoginComplateView();
        out.setUserId(userId);

        // ビューを返す。
        return out;
    }

    public Object error(Exception ex) {
        // ビューに「戻る」フラグをセット。
        view.setReturned(true);
        // ビューを返す。
        return view;
    }

}