package hondana.businesslogic;

import hondana.exception.BusinessException;
import hondana.view.IndexView;

/**
 * 持ち主登録
 */
public class RegistOwner extends AbstractBusinessLogic {

    {
        // クエリーランナーを取得。
        requiresQueryRunner = true;
    }

    public Object execute() {
        IndexView in = (IndexView) view;

        // ISBN、ユーザIDを取得。
        String isbn = in.getIsbn();
        String userId = session.getUser().getUserId();

        Object[] params = { isbn, userId };

        // 持ち主登録されていないかチェック。
        Integer count = (Integer) qr.getOne(
                "select count(*) from OWNERSHIP where BOOK = ? and OWNER = ?",
                params);

        if (count.intValue() > 0)
            throw BusinessException.RO001;

        // 持ち主情報を登録。
        qr.update("insert into OWNERSHIP values (?, ?, SYSDATE, SYSDATE)",
                params);
        return new Index();
    }

    public Object error(Exception ex) {
        return new Index();
    }

}