package hondana.businesslogic;

import hondana.exception.BusinessException;
import hondana.view.RegistUserConfirmView;
import hondana.view.RegistUserInputView;

/**
 * 登録ユーザ入力
 */
public class RegistUserInput extends AbstractBusinessLogic {

    {
        // クエリーランナーを取得。
        requiresQueryRunner = true;
    }

    public Object execute() {
        RegistUserInputView in = (RegistUserInputView) view;

        // ユーザIDとパスワードを取得。
        String userId = in.getUserId();
        String password = in.getPassword();

        // 同じユーザIDが存在しないかチェック。
        Integer count = (Integer) qr.getOne(
                "select count(ID) from USERS where ID = ?", userId);

        if (count.intValue() > 0)
            throw BusinessException.RU001;

        // ビューを生成して、ユーザIDとパスワードをセット。
        RegistUserConfirmView out = new RegistUserConfirmView();
        out.setUserId(userId);
        out.setPassword(password);

        // ビューを返す。
        return out;
    }

    public Object error(Exception ex) {
        // ビューに「戻る」フラグをセット。
        view.setReturned(true);
        // ビューを返す。
        return view;
    }

}