package hondana.businesslogic;

import hondana.exception.BusinessException;
import hondana.object.User;
import hondana.view.RegistUserComplateView;
import hondana.view.RegistUserConfirmView;
import hondana.view.View;

/**
 * ユーザ登録
 */
public class RegistUserRegist extends AbstractBusinessLogic {

    {
        // クエリーランナーを取得。
        requiresQueryRunner = true;
    }

    public Object execute() {
        RegistUserConfirmView in = (RegistUserConfirmView) view;

        // ユーザIDとパスワードを取得。
        String userId = in.getUserId();
        String password = in.getPassword();

        // 同じユーザIDが存在しないかチェック。
        Integer count = (Integer) qr.getOne(
                "select count(ID) from USERS where ID = ?", userId);

        if (count.intValue() > 0)
            throw BusinessException.RU001;

        // ユーザを登録。
        Object[] params = { userId, password };
        qr.update("insert into USERS VALUES (?, ?, SYSDATE, SYSDATE)", params);

        // ユーザをセッションにセット。
        User user = new User();
        user.setUserId(userId);
        session.setUser(user);

        // ビューを生成して、ユーザIDをセット。
        RegistUserComplateView out = new RegistUserComplateView();
        out.setUserId(userId);

        // ビューを返す。
        return out;
    }

    public Object error(Exception ex) {
        // スタックからビューを取得。
        View out = stack.pop();
        // ビューに「戻る」フラグをセット。
        out.setReturned(true);
        // ビューを返す。
        return out;
    }
}