package hondana.exception;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ExceptionHandler;
import org.apache.struts.config.ExceptionConfig;

/**
 * 例外ハンドラ
 */
public class AppExceptionHandler extends ExceptionHandler {

    private Log logger = LogFactory.getLog(this.getClass());

    private static final String EXCEPTION_KEY = "exception";

    /**
     * 例外処理を行う。
     */
    public ActionForward execute(Exception ex, ExceptionConfig config,
            ActionMapping mapping, ActionForm form, HttpServletRequest request,
            HttpServletResponse response) throws ServletException {
        // スタックトレースをログに出力。
        logger.error("exception thrown", ex);
        // 例外をリクエストにセット。
        request.setAttribute(EXCEPTION_KEY, new ExceptionWrapper(ex));
        // アクションフォワードを返す。
        return super.execute(ex, config, mapping, form, request, response);
    }

}