package hondana.exception;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

import org.apache.commons.lang.StringEscapeUtils;

/**
 * 例外ラッパー
 */
public class ExceptionWrapper {

    private Exception exception = null;

    public ExceptionWrapper(Exception exception) {
        this.exception = exception;
    }

    public String getMessage() {
        return exception.getMessage();
    }

    public String getStacktrace() {
        StringWriter writer = new StringWriter();
        PrintWriter printer = new PrintWriter(writer);
        exception.printStackTrace(printer);
        String stacktrace = writer.toString();
        printer.close();

        try {
            writer.close();
        } catch (IOException e) {
            throw new SystemException(e.getMessage(), e);
        }

        return stacktrace;
    }

    public String getStacktrace4html() {
        String stacktrace = getStacktrace();
        stacktrace = StringEscapeUtils.escapeXml(stacktrace);
        stacktrace = stacktrace.replaceAll(" ", "&nbsp;");
        stacktrace = stacktrace.replaceAll("\t", "&nbsp;&nbsp;&nbsp;&nbsp;");
        stacktrace = stacktrace.replaceAll("\n", "<br />");
        return stacktrace;
    }

}