package hondana.object.impl;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.Globals;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import hondana.object.Request;

/**
 * リクエスト(実装)
 */
public class RequestImpl implements Request {

    HttpServletRequest request = null;

    public RequestImpl(HttpServletRequest request) {
        this.request = request;
    }

    public Object get(String name) {
        return request.getAttribute(name);
    }

    public void set(String name, Object value) {
        request.setAttribute(name, value);
    }

    public void saveError(String key) {
        saveError(key, null);
    }

    public void saveError(String key, Object[] params) {
        ActionMessage error = null;

        if (params != null)
            error = new ActionMessage(key, params);
        else
            error = new ActionMessage(key);

        ActionErrors errors = (ActionErrors) request
                .getAttribute(Globals.ERROR_KEY);

        if (errors == null)
            errors = new ActionErrors();

        errors.add(ActionMessages.GLOBAL_MESSAGE, error);
        request.setAttribute(Globals.ERROR_KEY, errors);
    }

}