package hondana.object.impl;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import hondana.object.Session;
import hondana.object.User;
import hondana.object.ViewStack;

/**
 * セッション(実装)
 */
public class SessionImpl implements Session {

    HttpSession session = null;

    /////////////////////////////////////////////////////////////////
    // system attribute

    public SessionImpl(HttpServletRequest request) {
        session = request.getSession();
    }

    public Object get(String name) {
        return session.getAttribute(name);
    }

    public void set(String name, Object value) {
        session.setAttribute(name, value);
    }

    public ViewStack getViewStack() {
        return (ViewStack) session.getAttribute("stack");
    }

    public void setViewStack(ViewStack stack) {
        session.setAttribute("stack", stack);
    }

    /////////////////////////////////////////////////////////////////
    // ユーザ

    public User getUser() {
        return (User) session.getAttribute("user");
    }

    public void setUser(User user) {
        session.setAttribute("user", user);
    }

    public void removeUser() {
        session.removeAttribute("user");
    }

    /////////////////////////////////////////////////////////////////
    // ジャンルリスト

    public Map getCategories() {
        return (Map) session.getAttribute("categories");
    }

    public void setCategories(Map categories) {
        session.setAttribute("categories", categories);
    }

    public void removeCategories() {
        session.removeAttribute("categories");
    }

}