package hondana.util;

import java.lang.reflect.InvocationTargetException;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.oro.text.perl.Perl5Util;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.RequestProcessor;

/**
 * リクエストプロセッサ
 */
public class AppRequestProcessor extends RequestProcessor {

    protected void processPopulate(HttpServletRequest request,
            HttpServletResponse response, ActionForm form, ActionMapping mapping)
            throws ServletException {
        super.processPopulate(request, response, form, mapping);
        Enumeration names = request.getParameterNames();
        Perl5Util perl = new Perl5Util();

        // 正規表現にマッチしたパラメータをフォームにセット。
        while (names.hasMoreElements()) {
            String name = (String) names.nextElement();

            if (perl.match("m/^.+=.*(&.+=.*)*$/", name))
                populate(form, name);
        }
    }

    private void populate(ActionForm form, String params)
            throws ServletException {
        String[] pairs = params.split("&");
        Map pairMap = new HashMap();

        for (int i = 0; i < pairs.length; i++) {
            int pos = pairs[i].indexOf("=");

            if (pos >= 0) {
                String key = pairs[i].substring(0, pos);
                String value = pairs[i].substring(pos + 1);
                pairMap.put(key, value);
            } else {
                pairMap.put(pairs[i], null);
            }
        }

        try {
            BeanUtils.populate(form, pairMap);
        } catch (IllegalAccessException e) {
            throw new ServletException(e);
        } catch (InvocationTargetException e) {
            throw new ServletException(e);
        }
    }

}