package hondana.util;

import hondana.exception.IORuntimeException;

import java.io.IOException;
import java.io.InputStream;
import java.util.Map;
import java.util.Properties;

/**
 * コンフィグ
 */
public class Config {

    public static final String CONFIG_KEY = "config";

    private Map config = null;

    /////////////////////////////////////////////////////////////////
    // constructor

    public Config(InputStream is) throws IORuntimeException {
        try {
            config = new Properties();
            ((Properties) config).load(is);
        } catch (IOException e) {
            throw new IORuntimeException(e);
        }
    }

    public Config(Map config) throws IORuntimeException {
        this.config = config;
    }

    /////////////////////////////////////////////////////////////////
    // property

    public int getIndexRows() {
        return Integer.parseInt(get("index.rows"));
    }

    public String getJdbcUrl() {
        return get("jdbc.url");
    }

    public String getJdbcUser() {
        return get("jdbc.user");
    }

    public String getJdbcPassword() {
        return get("jdbc.password");
    }

    public String getJdbcDriver() {
        return get("jdbc.driver");
    }

    /////////////////////////////////////////////////////////////////
    // private method

    private String get(String key) {
        return (String) config.get(key);
    }

}