package hondana.util;

import hondana.exception.SystemException;

import java.text.ParseException;
import java.text.SimpleDateFormat;

/**
 * 日付
 */
public class Date extends java.util.Date {

    private static final String DATE_FORMAT = "yyyy-MM-dd HH:mm:ss";

    private static final SimpleDateFormat format = new SimpleDateFormat(
            DATE_FORMAT);

    public Date(java.util.Date date) {
        super();
        setTime(date.getTime());
    }

    public Date(String date) {
        super();
        try {
            setTime(format.parse(date).getTime());
        } catch (ParseException e) {
            throw new SystemException(e);
        }
    }

    public String toString() {
        return format.format(this);
    }

}