package hondana.util;

import java.io.BufferedInputStream;
import java.io.InputStream;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.action.PlugIn;
import org.apache.struts.config.ModuleConfig;

/**
 * コンフィグローダ
 */
public class LoadConfigPlugIn implements PlugIn {

    /**
     * ロガー
     */
    private Log logger = LogFactory.getLog(this.getClass());

    private String filename = null;

    public void setFilename(String filename) {
        this.filename = filename;
    }

    public void init(ActionServlet servlet, ModuleConfig config)
            throws ServletException {
        try {
            ServletContext context = servlet.getServletContext();
            logger.debug("load config file: " + filename);
            InputStream is = context.getResourceAsStream(filename);
            BufferedInputStream bis = null;

            Config appconfig = null;

            if (is != null) {
                bis = new BufferedInputStream(is);
                appconfig = new Config(bis);
            } else {
                throw new ServletException("cannot find config file '"
                        + filename + "'");
            }

            context.setAttribute(Config.CONFIG_KEY, appconfig);
        } catch (Exception e) {
            throw new ServletException(e.getMessage(), e);
        }
    }

    public void destroy() {
    }

}