package hondana.util.database;

import java.util.Map;

import hondana.exception.SQLRuntimeException;

/**
 * クエリーランナー
 */
public interface QueryRunner {

    /////////////////////////////////////////////////////////////////
    // reference method

    public Map[] query(String sql) throws SQLRuntimeException;

    public Map[] query(String sql, Object param) throws SQLRuntimeException;

    public Map[] query(String sql, Object[] params) throws SQLRuntimeException;

    public Map getRow(String sql) throws SQLRuntimeException;

    public Map getRow(String sql, Object param) throws SQLRuntimeException;

    public Map getRow(String sql, Object[] params) throws SQLRuntimeException;

    public Object getOne(String sql) throws SQLRuntimeException;

    public Object getOne(String sql, Object param) throws SQLRuntimeException;

    public Object getOne(String sql, Object[] params)
            throws SQLRuntimeException;

    /////////////////////////////////////////////////////////////////
    // update method

    public int update(String sql) throws SQLRuntimeException;

    public int update(String sql, Object param) throws SQLRuntimeException;

    public int update(String sql, Object[] params) throws SQLRuntimeException;

}