package hondana.view;

import hondana.exception.SystemException;
import hondana.util.Utils;

import java.lang.reflect.InvocationTargetException;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.validator.ValidatorActionForm;

/**
 * 抽象ビュー
 */
public abstract class AbstractView extends ValidatorActionForm implements View {

    /////////////////////////////////////////////////////////////////
    // trim method

    protected Set trims = new HashSet();

    public String getName() {
        String name = this.getClass().getName();
        int pos = name.lastIndexOf(".");

        if (pos >= 0)
            name = name.substring(pos + 1);

        return name;
    }

    /////////////////////////////////////////////////////////////////
    // button property

    private String btn = null;

    public String getBtn() {
        return btn;
    }

    public void setBtn(String btn) {
        this.btn = btn;
    }

    /////////////////////////////////////////////////////////////////
    // returned property

    private boolean returned = false;

    public boolean isReturned() {
        return returned;
    }

    public void setReturned(boolean returned) {
        this.returned = returned;
    }

    public void trim() {
        try {
            Iterator ite = trims.iterator();

            while (ite.hasNext()) {
                String name = (String) ite.next();
                String value = (String) PropertyUtils.getProperty(this, name);

                if (value == null)
                    continue;

                PropertyUtils.setProperty(this, name, Utils.mbtrim(value));
            }
        } catch (IllegalAccessException e) {
            throw new SystemException(e);
        } catch (InvocationTargetException e) {
            throw new SystemException(e);
        } catch (NoSuchMethodException e) {
            throw new SystemException(e);
        }
    }

    public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
        trim();
        return super.validate(arg0, arg1);
    }

}