<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page pageEncoding="UTF-8" %>
<%@ taglib uri="/tags/struts-html" prefix="html" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jstl/functions" %>
<%@ taglib tagdir="/WEB-INF/tags" prefix="tag" %>

<c:set var="books"    value="${IndexView.books}" />
<c:set var="pages"    value="${IndexView.pages}" />
<c:set var="page"     value="${IndexView.page}" />
<c:set var="indexRows" value="${config.indexRows}" />
<tag:prepareuser />

<tag:doctype />
<html>
 <head>
  <tag:head />
  <title>本棚</title>
 </head>
 <body>
  本棚
  <hr />
  <html:errors />
  <table>
<%-- ユーザの情報 ============================================== --%>
   <tr>
    <td>
     <table width="640">
      <tr valign="top">
       <td width="640" align="left">
        <font size="1">ようこそ <b>${username}</b> さん</font><br />
       </td>
       <c:if test="${login}">
        <td>
         <html:form action="/regist_book">
          <html:submit property="btn" value="本の登録" />
         </html:form>
        </td>
        <td>
         <html:form action="/logout">
          <html:submit property="btn" value="ログアウト" />
         </html:form>
        </td>
        <td>
         <html:form action="/delete_user">
          <html:submit property="btn" value="ユーザ情報削除" />
         </html:form>
        </td>
       </c:if>
       <c:if test="${!login}">
        <td>
         <html:form action="/login">
          <html:submit property="btn" value="ログイン" />
         </html:form>
        </td>
        <td>
         <html:form action="/regist_user">
          <html:submit property="btn" value="ユーザ登録" />
         </html:form>
        </td>
       </c:if>
      </tr>
     </table>
    </td>  
   </tr>
<%-- 本のリスト ================================================ --%>
   <tr>
    <td colspan="2">
     <c:choose>
      <c:when test="${books == null}">
       本は登録されていません。<br />
      </c:when>
      <c:otherwise>
       <table width="640">
        <tr>
         <td align="left">
          <c:if test="${page > 0}">
           <html:link action="/index?page=${page-1}">&lt;&lt;&lt;</html:link>
          </c:if>
         </td>
         <td colspan="2" align="right">
          <c:if test="${(page + 1) < (pages / indexRows) }">
           <html:link action="/index?page=${page+1}">&gt;&gt;&gt;</html:link>
          </c:if>
         </td>
        </tr>
        <c:forEach var="book" items="${books}"
         begin="${page * indexRows}" end="${(page + 1) * indexRows - 1}">
         <tr>
          <td colspan="3">
           <hr size="1">
          </td>
         </tr>
         <tr>
          <td rowspan="4" width="1">
           <tag:bookimg title="${book.title}" isbn="${book.isbn}" />
          </td>
          <td>
           <font size="3"><b>${fn:escapeXml(book.title)}</b></font>
          </td>
          <td rowspan="4" width="1" valign="top">
           <c:if test="${login}">
            <table>
             <tr>
              <td>
               <html:form action="/regist_owner">
                <html:submit property="page=${page}&isbn=${book.isbn}" value="持ち主登録" />
               </html:form>
              </td>
              <td>
               <html:form action="/delete_owner">
                <html:submit property="page=${page}&isbn=${book.isbn}" value="持ち主削除" />
               </html:form>
              </td>
             </tr>
            </table>
           </c:if>
          </td>
         </tr>
         <tr>
          <td>
           <font size="2">${fn:escapeXml(book.author)}</font>
          </td>
         </tr>
         <tr>
          <td>
           <font size="1">${fn:escapeXml(book.category)}</font>
          </td>
         </tr>
         <tr>
          <td>
           <font size="2"><b>持ち主:</b> ${book.owners}</font>
          </td>
         </tr>
        </c:forEach>
       </table>
      </c:otherwise>
     </c:choose>
    </td>
   </tr>
<%-- =========================================================== --%>
  </table>
 </body>
</html>
